import { ReactElement, ReactNode } from 'react';
export type HeadingLevels = 1 | 2 | 3 | 4 | 5 | 6;
export interface TableFlags {
    header?: boolean;
    align?: 'center' | 'left' | 'right' | null;
}
export type CustomReactRenderer = Partial<ReactRenderer>;
export type RendererMethods = keyof ReactRenderer;
export interface ReactRendererOptions {
    baseURL?: string;
    openLinksInNewTab?: boolean;
    langPrefix?: string;
    renderer?: CustomReactRenderer;
}
declare class ReactRenderer {
    #private;
    constructor(options?: ReactRendererOptions);
    get elementId(): number;
    heading(children: ReactNode, level: HeadingLevels): ReactElement<any, string | import("react").JSXElementConstructor<any>>;
    paragraph(children: ReactNode): ReactElement<any, string | import("react").JSXElementConstructor<any>>;
    link(href: string, text: ReactNode): ReactElement<any, string | import("react").JSXElementConstructor<any>>;
    image(src: string, alt: string, title?: string | null): ReactElement<any, string | import("react").JSXElementConstructor<any>>;
    codespan(code: ReactNode, lang?: string | null): ReactElement<any, string | import("react").JSXElementConstructor<any>>;
    code(code: ReactNode, lang: string | undefined): ReactElement<any, string | import("react").JSXElementConstructor<any>>;
    blockquote(children: ReactNode): ReactElement<any, string | import("react").JSXElementConstructor<any>>;
    list(children: ReactNode, ordered: boolean): ReactElement<any, string | import("react").JSXElementConstructor<any>>;
    listItem(children: ReactNode[]): ReactElement<any, string | import("react").JSXElementConstructor<any>>;
    checkbox(checked: ReactNode): ReactElement<any, string | import("react").JSXElementConstructor<any>>;
    table(children: ReactNode[]): ReactElement<any, string | import("react").JSXElementConstructor<any>>;
    tableHeader(children: ReactNode): ReactElement<any, string | import("react").JSXElementConstructor<any>>;
    tableBody(children: ReactNode[]): ReactElement<any, string | import("react").JSXElementConstructor<any>>;
    tableRow(children: ReactNode[]): ReactElement<any, string | import("react").JSXElementConstructor<any>>;
    tableCell(children: ReactNode[], flags: TableFlags): ReactElement<any, string | import("react").JSXElementConstructor<any>>;
    strong(children: ReactNode): ReactElement<any, string | import("react").JSXElementConstructor<any>>;
    em(children: ReactNode): ReactElement<any, string | import("react").JSXElementConstructor<any>>;
    del(children: ReactNode): ReactElement<any, string | import("react").JSXElementConstructor<any>>;
    text(text: ReactNode): ReactNode;
    html(html: ReactNode): ReactNode;
    hr(): ReactElement<any, string | import("react").JSXElementConstructor<any>>;
    br(): ReactElement<any, string | import("react").JSXElementConstructor<any>>;
}
export default ReactRenderer;
